! Transform from (X per m**2 of total ground) to (X per m**2 of nat/agri ground)
! and inverse operation
!
! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_natagritot.f90,v 1.2 2002/09/24 21:12:17 ssipsl Exp $
!
MODULE stomate_natagritot

  ! modules used:

  USE ioipsl
  USE stomate_constants

  IMPLICIT NONE

  ! private & public routines

  PRIVATE
  PUBLIC natagritot

CONTAINS

  SUBROUTINE natagritot (npts, direction, space_nat, field)

    !
    ! 0 declarations
    !

    ! 0.1 input

    ! Domain size
    INTEGER, INTENT(in)                               :: npts
    ! total -> nat/agri or nat/agri -> total ?
    INTEGER(long), INTENT(in)                         :: direction
    ! total natural space
    REAL(stnd), DIMENSION(npts), INTENT(in)           :: space_nat

    ! 0.2 modified 2-dimensional field

    ! characteristic to be transformed
    REAL(stnd), DIMENSION(npts,npft), INTENT(inout)   :: field

    ! 0.3 local

    ! index
    INTEGER(long)                                     :: j

    ! =========================================================================

    IF ( direction .EQ. ito_natagri ) THEN

      !
      ! 1 Transform from (X per m**2 of total ground) to (X per m**2 of nat/agri ground)
      !

      DO j = 1, npft

        IF ( natural(j) ) THEN

          WHERE ( space_nat(:) .GT. 0.0 )
            field(:,j) = field(:,j) / space_nat(:)
          ELSEWHERE
            field(:,j) = 0.0
          ENDWHERE

        ELSE

          WHERE ( space_nat(:) .LT. 1.0 )
            field(:,j) = field(:,j) / ( 1. - space_nat(:) )
          ELSEWHERE
            field(:,j) = 0.0
          ENDWHERE

        ENDIF

      ENDDO

    ELSEIF ( direction .EQ. ito_total ) THEN

      !
      ! 2 Transform from (X per m**2 of nat/agri ground) to (X per m**2 of total ground)
      !

      DO j = 1, npft

        IF ( natural(j) ) THEN

          field(:,j) = field(:,j) * space_nat(:)

        ELSE

          field(:,j) = field(:,j) * ( 1. - space_nat(:) )

        ENDIF

      ENDDO


    ELSE

      STOP 'natagritot: wrong direction'

    ENDIF

  END SUBROUTINE natagritot

END MODULE stomate_natagritot
